//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogIn																		//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>

#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif




int ErrorHandler(int CardID, int ErrorNumber);


int main()
{
	int				i						= 0;
	int				j						= 0;
	int				Result					= 0;
	unsigned int	CardID					= 0;
	unsigned int	ChannelNumber			= 0;
	double			Spannung[2];
	unsigned int	MaxValuesToSet			= 100;
	unsigned int	CurrentNumberOfValues	= 0;




//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck

	Spannung[0] =  2.5;																		// Beispielwerte
	Spannung[1] = -2.5;


//////////////////////////////////////////////////////////////////////////////////////////////
// Einzelwerte setzen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToSet)											// bis Maximalwert erreicht ist
	{
		if(_kbhit()) 
			if (_getch()==27) 
				break;


		for (j = 0; j < 2; j++)
		{
			Result = DA_WriteChannelVoltage(	CardID,										// ID der verwendeten Karte
												ChannelNumber,								// Kanal, welcher die Werte ausgibt
												Spannung[j]);								// Wert
		
			if (Result != 0)																// Wenn ein Fehler auftritt ...
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			CurrentNumberOfValues++;
			cout << "\rWerte: " << CurrentNumberOfValues << "/" << MaxValuesToSet << "     Spannungswert: " << Spannung[j] << "V";
		Sleep(50);
		}
	}


	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
