unit MAIv2_stdcall;

interface

// General Functions
function    GetDLLVersion(): PChar; stdcall; external 'maiv2dll.DLL' name 'GetDLLVersion';
function		ClearAllChannelLists(nInstance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name     'ClearAllChannelLists';
function		AddChannelToMixedScanlist( nInstance,  nChannelType,  nChannel,  nOversampling,  nGain,  nBipolar,  nDigitalType :Cardinal ): LongInt; stdcall;    external 'maiv2dll.DLL' name 'AddChannelToMixedScanlist';
function		StartMeasure( nInstance: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'StartMeasure';
function		StopMeasure( nInstance: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'StopMeasure';
function		SetStreamingMode( nInstance,  nStreamingMode: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'SetStreamingMode';
function		SetRunningMode( nInstance,  MasterSlave: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'SetRunningMode';
function		EnableSoftwareClock( nInstance, AIFetchADDataInUserMode: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'EnableSoftwareClock';
function		ConfigCard( nInstance,  TriggerExtern,  ExternEdge,  DifferenzMode,  p4: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'ConfigCard';
function		SetGlobalTriggerValues( nInstance,  nPreTrigger,  nPostTrigger,  nWaitForStartTrigger: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'SetGlobalTriggerValues';
function		ConfigMeasure( nInstance: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'ConfigMeasure';
function		IdentifierDevice( nInstance: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'IdentifierDevice';
function		IsUSBHighSpeed( nInstance : Cardinal;   IsUSBHighSpeed : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'IsUSBHighSpeed';

// Get Device Functions
function GetFirstDevice(): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetFirstDevice';
function GetFirstDeviceByType(DeviceType : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetFirstDeviceByType';
function OpenDevice(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'OpenDevice';
function CloseDevice(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'CloseDevice';
function IsDeviceOpen(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'IsDeviceOpen';
function GetErrorDescription(Instance : Cardinal; ErrorNumber: LongInt; ErrorDescription: PChar): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetErrorDescription';



// Eigenschaften der Karte
function	GetCardName(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetCardName';
function	GetCardProducer(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetCardProducer';
function	GetCardSeller(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetCardSeller';
function	GetManufacture_Name(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetDLLVersion';
function	GetSerialNumber(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetSerialNumber';
function	GetCustomer_Name(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetCustomer_Name';
function	GetCustomer_Number(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetCustomer_Number';
function	GetCustomer_DateOfPurchase(Instance : Cardinal): PChar; stdcall; external 'maiv2dll.DLL' name 'GetCustomer_DateOfPurchase';
function		GetADChannels(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetADChannels';
function		GetADSampleWidth(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetADSampleWidth';
function		GetADSampleRate(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetADSampleRate';
function		GetDAChannels(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetDAChannels';
function		GetDASampleWidth(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetDASampleWidth';
function		GetDASampleRate(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetDASampleRate';
function		GetTTLChannels(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetTTLChannels';
function		GetTTLSampleWidth(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetTTLSampleWidth';
function		GetTTLSampleRate(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetTTLSampleRate';
function		GetCTChannels(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetCTChannels';
function		GetCTSampleWidth(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetCTSampleWidth';
function		GetCTSampleRate(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetCTSampleRate';
function		GetPWMChannels(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetPWMChannels';
function		GetPWMSampleWidth(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetPWMSampleWidth';
function		GetPWMSampleRate(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetPWMSampleRate';
function		GetSoftwareExtension(Instance : Cardinal; pSWExtension: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetSoftwareExtension';
function		GetHardwareExtension(Instance : Cardinal; pHWExtension : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetHardwareExtension';
function		GetMeasurementProcessorVersion(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetMeasurementProcessorVersion';
function		GetControllerFirmwareVersion(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetControllerFirmwareVersion';
function		GetSystemDriverVersion(Instance : Cardinal; DLLVersion : PChar): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetSystemDriverVersion';
function		GetCardIDBySerial(Serial : PChar; nCardID: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetCardIDBySerial';
function		GetDeviceInfo( nCardID : Cardinal;  nDeviceType: PInteger; Serial :PChar): LongInt; stdcall;    external 'maiv2dll.DLL' name 'GetDeviceInfo';

// AD Functions
function		AD_ClearChannelList(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_ClearChannelList';
function		AD_AddChannelToList(Instance,  nChannel,  nOversampling,  nGain,  nBipolar : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_AddChannelToList';
function		AD_GetChannelListSize(Instance : Cardinal; CLSize: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_GetChannelListSize';
function		AD_ReadSingleValue(Instance,  nChannel,  nOversampling,  nGain,  nBipolar : Cardinal; RawValue : PInteger): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_ReadSingleValue';
function		AD_ReadSingleVoltage(Instance ,  nChannel,  nOversampling,  nGain,  nBipolar: Cardinal; Voltage: PDouble): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_ReadSingleVoltage';
function		AD_SetFrequency(Instance : Cardinal; fFrequency: Double ): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_SetFrequency';
function 	AD_GetFrequency(Instance : Cardinal; fFrequency: PDouble): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_GetFrequency';
function 	AD_ReadLastBurst(Instance : Cardinal; RawData : PInteger;  Value:PDouble; NumberOfValues: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_ReadLastBurst';
function 	AD_ReadData(Instance, ChannelListEntry : Cardinal; RawData: PInteger; Value:PDouble; ValuesPerChannel: PCardinal; bPartBlock,  bSkipData: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_ReadData';
function 	AD_ReadBinaryData(Instance : Cardinal; BinaryData: PByte; nLength : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_ReadBinaryData';
function		AD_GetStreamPipeLevel(Instance : Cardinal;fStreamPipeLevel:PDouble): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_GetStreamPipeLevel';
function 	AD_GetNumberOfValues(Instance : Cardinal; nNumberOfValues:PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_GetNumberOfValues';
function 	AD_StartMeasure(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_StartMeasure';
function 	AD_StopMeasure(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'AD_StopMeasure';

// CT Functions
function CT_ClearChannelList(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_ClearChannelList';
function CT_AddChannelToList(Instance,  nChannel : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_AddChannelToList';
function CT_GetChannelListSize(Instance : Cardinal; nCLSize: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_GetChannelListSize';
function CT_SetFrequency(Instance : Cardinal; fFreqency: Double): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_SetFrequency';
function CT_SetResolution(Instance ,  nChannel,   nResolution: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_SetResolution';
function CT_ImpulseCounter(Instance ,  nChannel,  nPresetValue,  nUpDown,  nEdge: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_ImpulseCounter';
function CT_FrequencyCounter(Instance,  nChannel,  nResolution,  nEdge,  nEachPeriod : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_FrequencyCounter';
function CT_PeriodCounter(Instance ,  nChannel,  nResolution,  nEdge,  nEachPeriod: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_PeriodCounter';
function CT_PulswidthCounter(Instance ,  nChannel,  nResolution,  nEdge,  nEachPeriod: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_PulswidthCounter';
function CT_IncrementalCounter(Instance,  nChannel,  nResolution,  nEdge,  nSoftwareReset,  nHardwareReset,  nHWResetEdge,  nInterpolation : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_IncrementalCounter';
function CT_UpDownCounter(Instance ,  nChannel,  nPresetValue,  nUpDown,  nEdge,  nSoftwareReset: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_UpDownCounter';
function CT_ReadData(Instance,  nChannelListEntry : Cardinal;  pBuffer,  nNumberOfValues : PCardinal;  bPartBlock,  bSkipData : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_ReadData';
function CT_ReadSingleValue(Instance ,  nChannel: Cardinal;  SingleValue : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_ReadSingleValue';
function CT_GetStreamPipeLevel(Instance : Cardinal; fStreamPipeLevel:PDouble): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_GetStreamPipeLevel';
function CT_GetNumberOfValues(Instance : Cardinal; nNumberOfValues : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_GetNumberOfValues';
function CT_StartMeasure(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_StartMeasure';
function CT_StopMeasure(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'CT_StopMeasure';

// DA funktions
function DA_SetRange(Instance,  nRange : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_SetRange';
function DA_ClearChannelList(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_ClearChannelList';
function DA_AddChannelToList(Instance ,  nChannel: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_AddChannelToList';
function DA_GetChannelListSize(Instance : Cardinal; nCLSize : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_GetChannelListSize';
function DA_SetFrequency(Instance : Cardinal; fFrequency : Double): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_SetFrequency';
function DA_StartOutput(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_StartOutput';
function DA_StopOutput(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_StopOutput';
function	DA_WriteChannelRaw(Instance ,  nChannel: Cardinal;  RawValue: Integer): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_WriteChannelRaw';
function	DA_WriteChannelVoltage(Instance, nChannel : Cardinal; VoltageValue: Double): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_WriteChannelVoltage';
function DA_WriteRawData(Instance, nChannelListEntry : Cardinal; pBuffer:PInteger; nLength: PCardinal;  bPartBlock : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_WriteRawData';
function DA_WriteScaledData(Instance ,  nChannelListEntry: Cardinal; fScaledValues: PDouble;  nLength: PCardinal;  bPartBlock: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_WriteScaledData';
function DA_GetFifoState(Instance ,  nChannel: Cardinal; nNumberOfValues: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'DA_GetFifoState';

//PWM Functions

function PWM_Enable(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'PWM_Enable';
function PWM_Disable(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'PWM_Disable';
function PWM_PreparePWMOutput(Instance,  nChannel,  StartFrequency,  nStartRatio : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'PWM_PreparePWMOutput';
function PWM_PrepareFMOutput(Instance ,  nChannel,  StartFrequency,  nPulsWidthRatio: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'PWM_PrepareFMOutput';
function PWM_WriteNewPWMRatio(Instance ,  nChannel,  Frequency,  nRatio: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'PWM_WriteNewPWMRatio';
function PWM_WriteNewFMRatio(Instance ,  nChannel,  Frequency,  nPulsWidthRatio: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'PWM_WriteNewFMRatio';


// TTL-Funktionen
function TTL_ClearChannelList(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_ClearChannelList';
function TTL_AddChannelToList(Instance ,  nChannel: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_AddChannelToList';
function TTL_GetChannelListSize(Instance : Cardinal;  nCLSize : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_GetChannelListSize';
function TTL_SetFrequency(Instance : Cardinal; fFrequency: Double): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_SetFrequency';
function TTL_SetChannelDirection(Instance,  nChannel,  nDirectionValue : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_SetChannelDirection';
function TTL_GetChannelDirection(Instance,  nChannel : Cardinal; nDirection: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_GetChannelDirection';
function TTL_ReadData(Instance : Cardinal; pBuffer,  nNumberOfValues: PCardinal;  bPartBlock, bSkipData: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_ReadData';
function TTL_ReadPort(Instance ,  nPort: Cardinal;nPortValue:PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_ReadPort';
function TTL_WritePort(Instance ,  nPort,  nPortValue: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_WritePort';
function TTL_ReadBit(Instance ,  nChannel: Cardinal;  nBit: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_ReadBit';
function TTL_WriteBit(Instance ,  nChannel,  nBit: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_WriteBit';
function TTL_GetStreamPipeLevel(Instance : Cardinal; fStreamPipeLevel : PDouble): LongInt; stdcall;    external 'maiv2dll.DLL' name'';
function TTL_GetNumberOfValues(Instance : Cardinal; nNumberOfValues: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_GetStreamPipeLevel';
function TTL_InitializeTargetSettings(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_InitializeTargetSettings';
function TTL_StartMeasure(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_StartMeasure';
function TTL_StopMeasure(Instance : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_StopMeasure';
function TTL_GetPortInfos(Instance : Cardinal; NumberOfPorts,  PortWidth,  NumberOfDigIn,  NumberOfDigOut: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'TTL_GetPortInfos';

// realtime Functions

function Realtime_AddTriggerEntry(Instance ,  nChannelListEntry,  nStartTriggerAktiv: Cardinal ;
                       dStartSchwellwert1,  dStartSchwellwert2 : Double;
											  nStartTriggerTyp,  nStartEnableAtStart,  nStartTriggerMessung,  nStartTriggerSetTTL,  nStartTriggerTTLKlemme,
											  nStartTriggerTTLZustand,  nStartTriggerTTLFlanke,  nStopTriggerAktiv: Cardinal ;
                        dStopSchwellwert1,  dStopSchwellwert2: Double;
											  nStopTriggerTyp,  nStopEnableAtStart,  nStopTriggerMessung,  nStopTriggerSetTTL,  nStopTriggerTTLKlemme,
											  nStopTriggerTTLZustand,  nStopTriggerTTLFlanke,  nRetriggerbar: Cardinal ;
                        AOIndexInChannelsRTList: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'Realtime_AddTriggerEntry';

function Realtime_AddFilterEntry(Instance ,  AIChannelListEntry,  AIFilterMode,  AIFilterOrder: Cardinal;
                                 AICoefficients : PDouble;
                                 AIOutputGainFactor : Double;
                                 AOIndexIndChannelsRTList: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'Realtime_AddFilterEntry';

function Realtime_DesignIIRFilter(  AISampleRate,  AICutoffFreqency,  AICutoffFreqency2,  AIPassabsorbtion,  AIStopbandattenuation : Double;
											 AIDesignMethod,  AIOrder : Cardinal;
											// Ausgabe:
											AOFilterMode : PCardinal;  AOCoefficientsList: PDouble): LongInt; stdcall;    external 'maiv2dll.DLL' name'Realtime_DesignIIRFilter';

function Realtime_DesignFIRFilter(   AISampleRate,  AICutoffFreqLow,  AICutoffFreqHigh : Double;
										    AIOrder,  AIFilterWindow : Cardinal;  AIWindowParameter: Double; AIScalePassband : Boolean;
											// Ausgabe: 
											  AOFilterMode : PCardinal;  AOCoefficientsList: PDouble): LongInt; stdcall;    external 'maiv2dll.DLL' name'Realtime_DesignFIRFilter';

function Realtime_AddPIDEntry(Instance,  nChannelListEntry : Cardinal; dPAnteil,  dIAnteil,  dDAnteil : Double;  nReglerArt : Cardinal;  Gain,  dSollwert,  dMinValue,  dMaxValue: Double;  nDAKanal: Cardinal;  nSampleFreq : Double;AOIndexInChannelsRTList : PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'Realtime_AddPIDEntry';

function Realtime_AddFFTEntry(Instance,  nChannelListEntry,  nAnzahlPunkte, nSpektrum: Cardinal;  dGain : Double; nFensterFunktion: Cardinal; dParameter: Double; AOIndexInChannelsRTList:PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'Realtime_AddFFTEntry';

function Realtime_FFT_ReadData(Instance,  nChannelListEntry : Cardinal; FFTData: PDouble;  nNumberOfValues: PCardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'Realtime_FFT_ReadData';

// SSI Funcitons

function SSI_SetBitWidth(Instance,  nBitWidth : Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'SSI_SetBitWidth';
function SSI_ConfigSSI(Instance,  nReset,  nResetEdge,  nActivePassiveMode,  nClockFrequency,  nEdge: Cardinal): LongInt; stdcall;    external 'maiv2dll.DLL' name'SSI_ConfigSSI';
                                                                                                                                    


implementation

end.
