unit UDigitalIN;

interface

implementation

uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;

function BitToStr( Int: Integer ): String;
var
  i, j: Integer;
begin
   Result := 'Low ';

  If Int > 0 then
    Result := 'High';

end;


var
	CardID, BitValue, ChannelNumber: Cardinal;
  i,Result                : Integer;
  KeyThatWasPressed       : AnsiChar;


begin



//////////////////////////////////////////////////////////////////////////////////////////////
//  CardID der ersten, verfgbaren Karte verwenden	                             						//
//////////////////////////////////////////////////////////////////////////////////////////////
  CardID := GetFirstDevice();
	if (CardID < 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
	end;

  WriteLn('Verwende Karte mit ID 0.');
  Writeln('Serial Number : '+GetSerialNumber(CardID));            // Seriennummer der Karte
  Writeln;
  Writeln;
  Writeln(' Druecken sie die Tasten 0-9, ');
  Writeln(' um den DIN-Pin mit dem entsprechenden Index zu lesen');
  Writeln(' (<Ecs> zum beenden).');
  while TRUE do
  begin
    if(KeyPressed(KeyThatWasPressed)) then
    begin
     if( KeyThatWasPressed = #27) then
        break;
    end ;
    Sleep(100);


    if ((KeyThatWasPressed >= Char('0')) and  ( KeyThatWasPressed <= Char('9')))then
    begin
      ChannelNumber := Cardinal(KeyThatWasPressed) - 48;
      Result := TTL_ReadBit(CardID, ChannelNumber, BitValue);
    	if (Result <> 0) then
      begin
        PrintError(CardID, Result);
        Exit;
      end;
      Write(Char(13)+' Channel: ' + InttoStr( ChannelNumber )+'    Value: ' +BitToStr(  BitValue ));
    end;


  end;

end.
