unit UDigitalPort;

interface

implementation

uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;


function IntToBin( Int: Integer ): String;
var
  i, j: Integer;
begin
  Result := '';
  i := 0;
  j := 1;
  while i = 0 do
    if( ( Int Mod (j*2) ) = Int )
      then i := j
      else j := j * 2;
  while i > 0 do
  begin
    if( ( Int div i ) > 0 ) then
    begin
      Int := Int - i;
      Result := Result + '1';
    end
    else Result := Result + '0';
    i := Trunc( i * 0.5 );
  end
 end;

var
	CardID, PortNumber, PortValue: Cardinal;
  Result                : Integer;
  KeyThatWasPressed       : AnsiChar;


begin
//////////////////////////////////////////////////////////////////////////////////////////////
//  Parameter                                                                    						//
//////////////////////////////////////////////////////////////////////////////////////////////
  PortNumber		:=  1;

//////////////////////////////////////////////////////////////////////////////////////////////
//  CardID der ersten, verfgbaren Karte verwenden	                             						//
//////////////////////////////////////////////////////////////////////////////////////////////
  CardID := GetFirstDevice();
	if (CardID < 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
	end;

  WriteLn('Verwende Karte mit ID 0.');
  Writeln('Serial Number : '+GetSerialNumber(CardID));            // Seriennummer der Karte
  Writeln;
  Writeln;
  Writeln(' Optionen :   (1) Port lesen');
  Writeln('              (2) Port schreiben');
  Writeln('              (0) beenden');
  while TRUE do
  begin
    if(KeyPressed(KeyThatWasPressed)) then
    begin
     if(( KeyThatWasPressed = Char('1')) OR (KeyThatWasPressed = Char('2')) or (KeyThatWasPressed = Char('0'))) then
        break;
    end ;
    Sleep(100);
  end;
  PortValue := 7;
  if KeyThatWasPressed = Char('0')  then
    Exit;

  if KeyThatWasPressed = Char('2')  then
      Result := TTL_WritePort(CardID, PortNumber, PortValue);

  Result := TTL_ReadPort(CardID, PortNumber,  PortValue);											// Digitalen Port auslesen

  Writeln;
  Writeln;
  Writeln(' Port status :' + IntToBin(PortValue) );

  WriteLn;
  WriteLn;
  Writeln('Fertig. (Bitte <Enter> druecken...)');
  Read(KeyThatWasPressed);
end.
