unit UIEPE;

interface

implementation

uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;

function KeyIsYXCV( Key: AnsiChar): Boolean;
begin
  Result := False;
  if Uppercase(string(Key))[1] in [Char('Y'),Char('X'),Char('C'),Char('V'),#27] then
      Result := true;

end;


var
	CardID,  ChannelNumber: Cardinal;
  Result                : Integer;
  KeyThatWasPressed       : AnsiChar;

begin



//////////////////////////////////////////////////////////////////////////////////////////////
//  CardID der ersten, verfgbaren Karte verwenden	                             						//
//////////////////////////////////////////////////////////////////////////////////////////////
  CardID := GetFirstDevice();
	if (CardID < 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
	end;

  WriteLn('Verwende Karte mit ID 0.');
  Writeln('Serial Number : '+GetSerialNumber(CardID));            // Seriennummer der Karte
  Writeln;
  Writeln;
  Writeln(' Waehlen Sie einen AD Kanal mit den Tasten 0-9 ');
  Writeln(' (<Ecs> zum beenden).');
  while TRUE do
  begin
    if(KeyPressed(KeyThatWasPressed)) then
    begin
     if( KeyThatWasPressed = #27) then
        break;
    end ;
    Sleep(100);


    if ((KeyThatWasPressed >= Char('0')) and  ( KeyThatWasPressed <= Char('9')))then
    begin
      ChannelNumber := Cardinal(KeyThatWasPressed) - 48;
      Writeln(' Waehlen Sie einen IEPE Modus:  <y>  DC, Massebezogen, IEPE off ');
      Writeln('                                <x>  DC, Differenz,    IEPE off');
      Writeln('                                <c>  AC, Massebezogen, IEPE off');
      Writeln('                                <v>  DC, Massebezogen, IEPE on');
      Writeln;
      while NOT KeyPressed(KeyThatWasPressed) OR NOT KeyIsYXCV(KeyThatWasPressed) do  Sleep(100);
      if KeyThatWasPressed = #27 then Break;
      case Uppercase(string(KeyThatWasPressed))[1] of
        Char('Y'): Result := AD_SetIEPE(CardID,ChannelNumber, iepeDC_SE_IEPE_off, true);
        Char('X'): Result := AD_SetIEPE(CardID,ChannelNumber, iepeDC_Diff_IEPE_off, true);
        Char('C'): Result := AD_SetIEPE(CardID,ChannelNumber, iepeAC_SE_IEPE_off, true);
        Char('V'): Result := AD_SetIEPE(CardID,ChannelNumber, iepeAC_SE_IEPE_on, true);
      else
      end;
      if (Result <> 0) then
      begin
        PrintError(CardID, Result);
        Break;
      end;
      ClearScreen;
      Writeln;
      Writeln;
      Writeln;
      Writeln;
      Writeln(' Waehlen Sie einen AD Kanal mit den Tasten 0-9 ');
      Writeln(' (<Ecs> zum beenden).');
      Writeln;

    end;


  end;
  Result := AD_ResetIEPE(CardID);
  if (Result <> 0) then
  begin
    PrintError(CardID, Result);
    Exit;
  end;
  WriteLn;
  WriteLn;
  Writeln('Fertig. (Bitte <Enter> druecken...)');
  Read(KeyThatWasPressed);
end.
