//////////////////////////////////////////////////////////////////////////////////////////////
// Analoge Einzelwerterfassung																//
//////////////////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <conio.h>
#include <iostream>

#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif



int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	int				Result					= 0;
	double			SingleVoltage			= 0;
	unsigned int	CardID					= 0;
	unsigned int	ChannelNumber			= 0;
	unsigned int	Oversampling			= oversamplingDISABLED;
	unsigned int	Gain					= gainDisabled;
	unsigned int	polarity				= polBIPOLAR;
	unsigned int	MaxValuesToGet			= 2500;
	unsigned int	CurrentNumberOfValues	= 0;
	char Serial[25];



	//cout << "Geben Sie die Seriennummer der gewunschten Karte an: ";						// Beispiel fr Messungen nach Eingabe der Seriennummer
	//cin >> Serial;

	//Result = GetCardIDBySerial(Serial, &CardID);	
	//if (Result != 0)
	//{
	//	ErrorHandler(CardID, Result);
	//	system("Pause");
	//	return 0;
	//}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messwerte abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Bedingung fr Beendigung der Schleife
	{
		if(_kbhit()) 
			if (_getch()==27) 
				break;

		Result = AD_ReadSingleVoltage(	CardID,												// ID der anzusprechenden Karte				
										ChannelNumber,										// Kanal
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										polBIPOLAR,											// Basic-Karten untersttzen nur polBIPOLAR
										&SingleVoltage);									// Einzelner Spannungswert
		
		if (Result != 0)																	// Wenn Rckgabewert nicht "0", dann liegt ein Fehler vor
		{																					
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		CurrentNumberOfValues++;															// Zhler fr erfasste Werte
		
		// Konsolenausgabe
		cout << "\rWerte: " << CurrentNumberOfValues << "/" << MaxValuesToGet << "     Spannung: " << SingleVoltage << " Volt";	
		Sleep(1);
	}
	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
