unit ConsoleHelper;


interface


procedure ClearScreen();

function  KeyPressed(var KeyThatWasPressed:AnsiChar):Boolean;




implementation

uses   SysUtils, Windows;

procedure ClearScreen();
var
nConsoleHandle : Integer;
lwWritten : Longword;
Coord : TCoord;
begin
    Coord.X := 0;
    Coord.Y := 0;
    nConsoleHandle := GetStdHandle(STD_OUTPUT_HANDLE);
    FillConsoleOutputCharacter(nConsoleHandle, ' ', 80*24, Coord, lwWritten);
    SetConsoleCursorPosition( nConsoleHandle, Coord);
end;



function KeyPressed(var KeyThatWasPressed:AnsiChar):Boolean;
var
    lpNumberOfEvents     : DWORD;
    lpBuffer             : TInputRecord;
    lpNumberOfEventsRead : DWORD;
    nStdHandle           : THandle;
begin
    Result:=false;
    //get the console handle
    nStdHandle := GetStdHandle(STD_INPUT_HANDLE);
    lpNumberOfEvents:=0;
    //get the number of events
    GetNumberOfConsoleInputEvents(nStdHandle,lpNumberOfEvents);
    if lpNumberOfEvents<> 0 then
    begin
        //retrieve the event
        ReadConsoleInput(nStdHandle,lpBuffer,1,lpNumberOfEventsRead);
        if lpNumberOfEventsRead <> 0 then
        begin
            if lpBuffer.EventType = KEY_EVENT then //is a Keyboard event?
            begin
                if lpBuffer.Event.KeyEvent.bKeyDown then //the key was pressed?
                begin
                    KeyThatWasPressed := lpBuffer.Event.KeyEvent.AsciiChar  ;
                    Result:=true;
                end
                else
                    FlushConsoleInputBuffer(nStdHandle); //flush the buffer
            end
            else
                FlushConsoleInputBuffer(nStdHandle);//flush the buffer
        end;
      end;
end;


end.
